using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DVM_Management_Center.GUI
{
    public partial class SetPosition : Form
    {
        bool dragDrop = false;

        private PictureBox _pbMap;
        public PictureBox PbMap
        {
            get { return _pbMap; }
            set { _pbMap = value; }
        }

        public int PositionTop
        {
            get { return label.Top - pbBox.Top; }
            set { label.Top = value + pbBox.Top; }
        }

        public int PositionLeft
        {
            get { return label.Left - pbBox.Left; }
            set { label.Left = value + pbBox.Left; }
        }

        public SetPosition()
        {
            InitializeComponent();
        }

        private void setPosition_Load(object sender, EventArgs e)
        {
            pbBox.Image = _pbMap.Image;
            pbBox.Size = _pbMap.Image.Size;
            this.Width = pbBox.Width + 30;
            this.Height = pbBox.Height + 80;
        }

        private void pbBox_DoubleClick(object sender, EventArgs e)
        {
            label.Left = this.PointToClient(Control.MousePosition).X - label.Width / 2;
            label.Top = this.PointToClient(Control.MousePosition).Y - label.Height / 2;
        }

        private void label_DoubleClick(object sender, EventArgs e)
        {
            this.Close();
        }

        private void label_MouseDown(object sender, MouseEventArgs e)
        {
            dragDrop = true;
        }

        private void label_MouseUp(object sender, MouseEventArgs e)
        {
            dragDrop = false;
        }

        private void label_MouseMove(object sender, MouseEventArgs e)
        {
            if (this.PointToClient(Control.MousePosition).X > pbBox.Left + label.Width / 2
                 && this.PointToClient(Control.MousePosition).X < pbBox.Left + pbBox.Width - label.Width / 2
                 && dragDrop == true)
            {
                label.Left = this.PointToClient(Control.MousePosition).X - label.Width / 2;   
            }

            if (this.PointToClient(Control.MousePosition).Y > pbBox.Top + label.Height / 2
                 && this.PointToClient(Control.MousePosition).Y < pbBox.Top + pbBox.Height - label.Height / 2
                 && dragDrop == true)
            {
                label.Top = this.PointToClient(Control.MousePosition).Y - label.Height / 2;
            }
        }

        private void OK_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}